#include <bits/stdc++.h>

using namespace std;

int a[200010];
int b[200010];
int pom2;
int pom;

int vre(int l, int d){
    if(l==d && l==pom2) return 0;
    if(l==d){
        if(b[l]==1) pom=l;
        return b[l];
    }
    if(l==d-1 && l==pom2){
        if(b[d]==1){
            pom=d;
            return 1;
        }
        return 0;
    }
    if(l==d-1){
        if(b[l]==1 && b[d]==0) pom=l;
        if(b[d]==1 && b[l]==0) pom=d;
        return b[l]+b[d];
    }
    return vre(l,(l+d)/2)+vre((l+d)/2+1,d);
}

int main(){
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int n; cin>>n;
    for(int i=0;i<n;i++) cin>>a[i];
    for(int i=1;i<n;i++) if(a[i]<a[i-1]) b[i]=1;
    //nap(0,n-1,0);
    int q; cin>>q;
    for(int i=0;i<q;i++){
        int l,d; cin>>l>>d;
        l--;d--;
        pom2=l;
        //vre(l,d);
        if(vre(l,d)==0) cout<<"DA\n";
        else if(vre(l,d)==1){
            int ind=pom;
            if(ind==1||ind==l+1||(a[ind-2]<=a[ind])||ind==n-1||ind==d||(a[ind-1]<=a[ind+1])) cout<<"DA\n";
            else cout<<"NE\n";
        }
        else cout<<"NE\n";
    }
    return 0;
}